function [J, grad] = costFunctionReg(theta, X, y, lambda)
%COSTFUNCTIONREG Compute cost and gradient for logistic regression with regularization
%   J = COSTFUNCTIONREG(theta, X, y, lambda) computes the cost of using
%   theta as the parameter for regularized logistic regression and the
%   gradient of the cost w.r.t. to the parameters. 

% Initialize some useful values
m = length(y); % number of training examples

% You need to return the following variables correctly 
%J = 0;
%grad = zeros(size(theta));

% ====================== YOUR CODE HERE ======================
% Instructions: Compute the cost of a particular choice of theta.
%               You should set J to the cost.
%               Compute the partial derivatives and set grad to the partial
%               derivatives of the cost w.r.t. each parameter in theta


thetaFilter = ones(size(theta, 1), 1);
thetaFilter(1) = 0;
theta2 = thetaFilter .* theta;
pos = y .* log(sigmoid(X * theta));
neg = (1 - y) .* log(1 - sigmoid(X * theta));

% did not simplify the operations to keep the two goals (minimization and
% penalty/genralization) distinctly separate
J = ( - sum( pos + neg ) / m ) + (lambda / (2 * m) ) .* (theta2' * theta2);

grad = ( ( X' * (sigmoid(X * theta) - y ) ) / m ) + (lambda / m ) .* theta2;


% =============================================================

end
